/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.dao.hibernate;

import com.rjconsultores.ventaboletos.dao.MarcaClaseServicioDAO;
import com.rjconsultores.ventaboletos.entidad.ClaseServicio;
import com.rjconsultores.ventaboletos.entidad.Marca;
import com.rjconsultores.ventaboletos.entidad.MarcaClaseServicio;
import com.rjconsultores.ventaboletos.entidad.MarcaClaseServicioPK;

import java.util.List;

import org.hibernate.Criteria;
import org.hibernate.Query;
import org.hibernate.SessionFactory;
import org.hibernate.criterion.Restrictions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.stereotype.Repository;

/**
 * 
 * @author Administrador
 */
@Repository("marcaClaseServicioDAO")
public class MarcaClaseServicioHibernateDAO
		extends GenericHibernateDAO<MarcaClaseServicio, MarcaClaseServicioPK>
		implements MarcaClaseServicioDAO {

	@Autowired
	public MarcaClaseServicioHibernateDAO(@Qualifier("sessionFactory") SessionFactory factory) {
		setSessionFactory(factory);
	}

	@Override
	public List<MarcaClaseServicio> obtenerTodos() {
		Criteria c = getSession().createCriteria(getPersistentClass());
		c.add(Restrictions.eq(ACTIVO, Boolean.TRUE));

		return c.list();
	}

	public List<Marca> buscar(ClaseServicio clase) {

		StringBuilder hql = new StringBuilder();
		hql.append(" select mc.marcaClaseservicioPK.marca ");
		hql.append("     from MarcaClaseServicio mc  ");
		hql.append(" where mc.activo = 1 and mc.marcaClaseservicioPK.marca.activo=1 ");
		hql.append("           and mc.marcaClaseservicioPK.claseservicio.claseservicioId = " + clase.getClaseservicioId());

		Query q = getSession().createQuery(hql.toString());

		return q.list();
	}

	@Override
	public List<Marca> buscarPorEmpresasPermitidas(ClaseServicio clase, List<Integer> idsEmpresa) {
		
		StringBuilder hql = new StringBuilder();
		hql.append(" select mc.marcaClaseservicioPK.marca ");
		hql.append("     from MarcaClaseServicio mc  ");
		hql.append(" where mc.activo = 1 and mc.marcaClaseservicioPK.marca.activo=1 ");
		hql.append("           and mc.marcaClaseservicioPK.claseservicio.claseservicioId = :idClase");
		hql.append("           and mc.marcaClaseservicioPK.marca.empresa.empresaId IN (:idsEmpresa)");
		
		Query q = getSession().createQuery(hql.toString());
		q.setParameter("idClase", clase.getClaseservicioId());
		q.setParameterList("idsEmpresa", idsEmpresa);
		
		return q.list();
	}
}
